{% extends '@DemosPlanCore/DemosPlanCore/procedure.html.twig' %}

{% block component_part %}

    {% include '@DemosPlanCore/DemosPlanCore/includes/base_pageheader.html.twig' with {
        heading: 'tag.administration' |trans
    } %}
    <p class="u-mb">{{ "text.tags.administration"|trans }}</p>

    <form
        action="{{ path("DemosPlan_statement_administration_tags_edit", {'procedure':templateVars.procedure}) }}"
        method="post"
        name="tag_edit">

        {# global actions #}
        <div class="u-mb-0_5 u-nojs-hide--block">

            {# mark all #}
            <label class="u-mb-0 u-mh-0_75 inline-block">
                <input
                    class="u-mr-0"
                    type="checkbox"
                    data-form-actions-check-all
                    data-cy="checkAllItems"
                    name="checkAllItems"
                    value="">
                {{ "all"|trans }}
            </label>

            <button
                class="btn-icns u-ml-0_25"
                name="r_delete"
                data-cy="deleteSelectedItems"
                data-form-actions-confirm="{{ "check.items.marked.delete" |trans }}">
                <i class="fa fa-times-circle"></i> {{ "items.marked.delete"|trans }}
            </button>

        </div>

        {# list of tags #}
        <table>

            {# the second column adapts to available width while the other cols have a fixed width #}
            <colgroup>
                <col class="width-40">
                <col class="">
                <col class="width-120">
                <col class="width-120">
            </colgroup>

            <thead>
                <tr>
                    <th class="checkbox">
                        <i class="fa fa-check-square-o"></i>
                    </th>
                    <th>
                        {{ "topic.or.tag" |trans }}
                    </th>
                    <th>
                        {{ "boilerplate" |trans }}
                    </th>
                    <th class="text-center">
                        {{ "actions" |trans }}
                    </th>
                </tr>
            </thead>

            <tbody>

            {% for topic in templateVars.topics %}

                <tr>

                    <td colspan="4" class="u-p-0 text-left">

                        <table class="c-table u-mb-0">

                            <colgroup>
                                <col class="width-40">
                                <col class="">
                                <col class="width-120">
                                <col class="width-120">
                            </colgroup>

                            <tr class="hide-visually">
                                <th>{{ "choose"|trans }}</th>
                                <th>{{ "topic"|trans }}</th>
                                <th></th>
                                <th>{{ "edit"|trans }}</th>
                            </tr>

                            <tr
                                id="{{ topic.id }}"
                                data-cy="TopicField"
                                class="o-animate--bg-color">
                                <td class="checkbox u-ph-0 u-pb-0_25 u-pt-0_5 text-center">
                                    <input type="hidden" name="{{ topic.id }}:r_itemtype" value="topic">

                                    <label class="u-m-0">
                                        <input type="checkbox" name="{{ topic.id }}:r_selected" data-checkable-item>
                                    </label>
                                </td>

                                <td class="o-toggle u-pr-0 u-pb-0_25 u-pt-0_5 o-hellip--td" title="{{ "topic" |trans }}: {{ topic.title }}">

                                    <div class="weight--bold o-hellip">
                                        {{ topic.title }}
                                    </div>

                                    <div class="overflow-hidden">
                                        <div class="o-toggle__target u-mv-0_25 flex space-inline-s" data-toggle-id="insert-{{ topic.id }}">
                                            <input
                                                data-form-actions-submit-target="#topicInsertBtn-{{ topic.id }}"
                                                class="o-form__control-input u-2-of-5"
                                                type="text"
                                                data-cy="nameNewTag"
                                                name="{{ topic.id }}:r_newtags"
                                                placeholder="{{ "tag.name" |trans }}"
                                                aria-label="{{ "tag.name" |trans }}">

                                            <button
                                                class="btn btn--primary"
                                                name="r_createtags"
                                                data-cy="createNewTag"
                                                value="{{ topic.id }}"
                                                id="topicInsertBtn-{{ topic.id }}">
                                                {{ "topic.insertTag" |trans }}
                                            </button>
                                        </div>
                                    </div>

                                    <div class="overflow-hidden">
                                        <div class="o-toggle__target u-mv-0_25 flex space-inline-s" data-toggle-id="rename-{{ topic.id }}">
                                            <input
                                                data-cy="renameTopicField"
                                                data-form-actions-submit-target="#topicRenameBtn-{{ topic.id }}"
                                                class="o-form__control-input u-2-of-5"
                                                type="text"
                                                value="{{ topic.title }}"
                                                name="{{ topic.id }}:r_rename">

                                            <button
                                                class="btn btn--primary"
                                                name="r_renametopic"
                                                data-cy="renameTopicSave"
                                                value="{{ topic.id }}"
                                                id="topicRenameBtn-{{ topic.id }}">
                                                {{ "topic.rename" |trans }}
                                            </button>
                                        </div>
                                    </div>

                                </td>

                                <td></td>

                                <td class="u-pb-0_25 u-pt-0_5 text-right">
                                    <a
                                        href="#"
                                        data-cy="addNewTag"
                                        class="o-toggle__trigger u-mr-0_5 js__toggleAnything"
                                        data-toggle-container="form"
                                        data-toggle="#insert-{{ topic.id }}"
                                        data-toggle-prevent-default
                                        title="{{ "topic.insertTag" |trans }}">
                                        <i class="fa fa-plus" aria-hidden="true"></i>
                                    </a>

                                    <a
                                        href="#"
                                        data-cy="editTopic"
                                        class="o-toggle__trigger u-mr-0_5 js__toggleAnything"
                                        data-toggle-container="form"
                                        data-toggle="#rename-{{ topic.id }}"
                                        data-toggle-prevent-default
                                        title="{{ "topic.rename" |trans }}">
                                        <i class="fa fa-pencil" aria-hidden="true"></i>
                                    </a>

                                    <button
                                        class="btn--blank o-link--default align-top"
                                        name="r_deletetopic"
                                        value="{{ topic.id }}"
                                        data-form-actions-confirm="{{ "check.topic.delete.tags" | trans({ topic: topic.title }) }}"
                                        data-form-actions-confirm-simple
                                        title="{{ "topic.delete" |trans }}">
                                        <i class="fa fa-trash"></i>
                                    </button>
                                </td>
                            </tr>

                            {# loop over found tags #}
                            {% for tag in topic.tags|default([]) %}
                            <tr
                                id="{{ tag.id }}"
                                data-cy="TagField"
                                class="o-animate--bg-color">

                                <input type="hidden" name="{{ tag.id }}:r_itemtype" value="tag">
                                <td class="u-ph-0 {{ loop.last ? 'u-pt-0_25 u-pb-0_5' : 'u-pv-0_25' }} text-center">
                                    <label class="u-m-0">
                                        <input type="checkbox" name="{{ tag.id }}:r_selected" data-checkable-item>
                                    </label>
                                </td>

                                <td class="o-toggle u-pr-0 u-pl-0_5 {{ loop.last ? 'u-pt-0_25 u-pb-0_5' : 'u-pv-0_25' }} o-hellip--td">
                                    <a
                                        class="u-1-of-1 block o-hellip"
                                        href="{{ path('DemosPlan_statement_administration_tag', {'procedure':procedure, 'tag':tag.id}) }}"
                                        title="{{ "tag.update" |trans }}: {{ tag.title }}">
                                        {{ tag.title }}
                                    </a>

                                    <div class="overflow-hidden">
                                        <div class="o-toggle__target u-mv-0_25 flex space-inline-s" data-toggle-id="rename-tag-{{ tag.id }}">
                                            <input
                                                data-cy="renameNewNameTag"
                                                data-form-actions-submit-target="#tagRenameBtn-{{ tag.id }}"
                                                class="o-form__control-input u-2-of-5"
                                                value="{{ tag.title }}"
                                                type="text"
                                                name="{{ tag.id }}:r_tag_newname">

                                            <button
                                                class="btn btn--primary"
                                                name="r_renametag"
                                                data-cy="saveNewNameTag"
                                                value="{{ tag.id }}"
                                                id="tagRenameBtn-{{ tag.id }}">
                                                {{ "tag.rename" |trans }}
                                            </button>
                                        </div>
                                    </div>

                                    <div class="overflow-hidden">
                                        <div class="o-toggle__target u-mv-0_25 flex space-inline-s" data-toggle-id="move-tag-{{ tag.id }}">
                                            <select
                                                data-cy="moveTagSelect"
                                                class="o-form__control-select u-2-of-5"
                                                name="{{ tag.id }}:r_moveto">
                                                {% for topic in templateVars.topics %}
                                                    <option data-cy="moveTagOption" value="{{ topic.id }}">{{ topic.title }}</option>
                                                {% endfor %}
                                            </select>

                                            <button
                                                class="btn btn--primary"
                                                data-cy="moveTagSubmitBtn"
                                                name="r_move"
                                                value="{{ tag.id }}">
                                                {{ "tag.move.toTopic" |trans }}
                                            </button>
                                        </div>
                                    </div>

                                </td>

                                <td class="u-ph-0 {{ loop.last ? 'u-pt-0_25 u-pb-0_5' : 'u-pv-0_25' }} text-center">
                                    {% if tag.boilerplate %}
                                        <dp-tooltip-icon
                                            class="color--grey"
                                            icon="fa-file"
                                            text="{{ tag.boilerplate.text }}"
                                        ></dp-tooltip-icon>
                                    {% endif %}
                                </td>

                                <td class="{{ loop.last ? 'u-pt-0_25 u-pb-0_5' : 'u-pv-0_25' }} text-right">
                                    <a
                                        href="#"
                                        data-cy="moveTag"
                                        class="o-toggle__trigger u-mr-0_5 js__toggleAnything"
                                        data-toggle-container="form"
                                        data-toggle="#move-tag-{{ tag.id }}"
                                        data-toggle-prevent-default
                                        title="{{ "tag.move" |trans }}">
                                        <i class="fa fa-angle-double-right" aria-hidden="true"></i>
                                    </a>

                                    <a
                                        href="#"
                                        data-cy="renameTagField"
                                        class="o-toggle__trigger u-mr-0_5 js__toggleAnything"
                                        data-toggle-container="form"
                                        data-toggle="#rename-tag-{{ tag.id }}"
                                        data-toggle-prevent-default
                                        title="{{ "tag.rename" |trans }}">
                                        <i class="fa fa-pencil" aria-hidden="true"></i>
                                    </a>

                                    <button
                                        class="btn--blank o-link--default align-top"
                                        data-cy="deleteTagField"
                                        name="r_deletetag"
                                        value="{{ tag.id }}"
                                        data-form-actions-confirm="{{ "check.tag.delete" | trans({ tag: tag.title }) }}"
                                        data-form-actions-confirm-simple
                                        title="{{ "tag.delete" |trans }}">
                                        <i class="fa fa-trash"></i>
                                    </button>
                                </td>

                            </tr>
                            {% else %}
                                <tr>
                                    <td></td>
                                    <td colspan="3" class="u-ph-0 u-pl-0_5 u-pv-0_25 text-left">
                                        {{ "topic.noentries" |trans }}
                                        <br>
                                        <a
                                            href="#"
                                            class="o-toggle__trigger u-mr-0_5 js__toggleAnything"
                                            data-toggle-container="form"
                                            data-toggle="#insert-{{ topic.id }}"
                                            data-toggle-prevent-default>
                                            {{ "topic.insertFirstTag" |trans }}
                                        </a>
                                    </td>
                                </tr>
                            {% endfor %}
                        </table>

                    </td>

                </tr>

            {% else %}
                <tr>
                    <td colspan="4" class="u-ph-0 u-pl-0_5 u-pv-0_25 text-left">
                        {{ "tags.noentries"|trans }}
                    </td>
                </tr>
            {% endfor %}

            </tbody>

        </table>

        {# other options #}
        <fieldset class="flow-root u-pb-0 u-mt-2">

            {# new topic #}
            <div class="layout u-mb">
                <label class="layout__item u-2-of-3">
                    {{ "topic.create" |trans }}
                    <input
                        data-form-actions-submit-target="#createNewTopic"
                        class="layout__item o-form__control-input"
                        type="text"
                        name="r_newTopic"
                        data-cy="nameNewTopic"
                        placeholder="{{ "topic.name" |trans }}">
                </label><!--
             --><div class="layout__item u-1-of-3">
                    <button
                        class="btn btn--primary u-mt width-100p"
                        id="createNewTopic"
                        name="r_create"
                        data-cy="addNewTopic">
                        {{ "topic.create.short" |trans }}
                    </button>
                </div>
            </div>

            {# import #}
            <dp-tooltip-icon
                class="float-right"
                icon="fa-question-circle"
                text="{{ "tags.import.help"|trans }}"
            ></dp-tooltip-icon>

            <div class="u-mb">
                {{  fileupload(
                    "r_importCsv",
                    "tags.import"|trans,
                    "csv",
                    "form.button.upload.csv",
                    1,
                    false
                )
                }}
            </div>

            <button name="r_import" class="btn btn--primary float-right u-mb-2">
                {{ "tags.import" |trans }}
            </button>

        </fieldset>

    </form>

{% endblock component_part %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundle('statement-listTags.js') }}
{% endblock javascripts %}
